(function(g,f){typeof exports==='object'&&typeof module!=='undefined'?f(exports):typeof define==='function'&&define.amd?define(['exports'],f):(g=typeof globalThis!=='undefined'?globalThis:g||self,f(g.VueLazyLoading={}));}(this,(function(exports){'use strict';var LazyCore = function () {
  function LazyCore(options) {
    var _a, _b;

    this.useNative = (_a = options === null || options === void 0 ? void 0 : options.useNative) !== null && _a !== void 0 ? _a : true;
    this.rootMargin = (_b = options === null || options === void 0 ? void 0 : options.rootMargin) !== null && _b !== void 0 ? _b : '200px';
  }

  LazyCore.prototype.init = function () {
    if (this.useNative && 'loading' in HTMLImageElement.prototype) {
      this.type = 'loading';
    } else if (window.IntersectionObserver) {
      this.type = 'observer';
      this.setObserver();
    } else {
      this.type = 'none';
      error('Your browser does not support IntersectionObserver. https://github.com/tolking/vue-lazy-loading#Browser-Support');
    }
  };

  LazyCore.prototype.bind = function (el, binding) {
    !this.type && this.init();
    binding.arg !== 'bg' && binding.arg !== 'bgset' && !el.hasAttribute('loading') && el.setAttribute('loading', 'lazy');
    this.update(el, binding);
  };

  LazyCore.prototype.update = function (el, _a) {
    var oldValue = _a.oldValue,
        value = _a.value,
        arg = _a.arg;
    if (oldValue === value) return;
    var isEager = el.getAttribute('loading') === 'eager';

    switch (arg) {
      case undefined:
        el.hasAttribute('src') && el.removeAttribute('src');

        if (!isEager && this.type === 'observer') {
          el.setAttribute('data-src', value);
          this.io.observe(el);
        } else {
          el.setAttribute('src', value);
        }

        break;

      case 'set':
      case 'srcset':
        el.hasAttribute('srcset') && el.removeAttribute('srcset');

        if (!isEager && this.type === 'observer') {
          el.setAttribute('data-srcset', value);
          this.io.observe(el);
        } else {
          el.setAttribute('srcset', value);
        }

        break;

      case 'bg':
        if (!isEager && (this.type === 'loading' || this.type === 'observer')) {
          !this.io && this.setObserver();
          el.setAttribute('data-bg', value);
          this.io.observe(el);
        } else {
          setStyle(el, 'bg', value);
        }

        break;

      case 'bgset':
        if (!isEager && (this.type === 'loading' || this.type === 'observer')) {
          !this.io && this.setObserver();
          el.setAttribute('data-bgset', value);
          this.io.observe(el);
        } else {
          setStyle(el, 'bgset', value);
        }

        break;

      default:
        error('One of v-lazy, v-lazy:set, v-lazy:srcset, v-lazy:bg, v-lazy:bgset');
        break;
    }
  };

  LazyCore.prototype.unbind = function (el) {
    this.type === 'observer' && this.io.unobserve(el);
  };

  LazyCore.prototype.setObserver = function () {
    var _this = this;

    this.io = new IntersectionObserver(function (entries) {
      entries.forEach(function (item) {
        if (item.isIntersecting) {
          var el = item.target;

          var _a = getDataset(el),
              src = _a.src,
              srcset = _a.srcset,
              bg = _a.bg,
              bgset = _a.bgset;

          bg && setStyle(el, 'bg', bg);
          bgset && setStyle(el, 'bgset', bgset);
          src && el.setAttribute('src', src);
          srcset && el.setAttribute('srcset', srcset);

          _this.io.unobserve(item.target);
        }
      });
    }, {
      rootMargin: this.rootMargin
    });
  };

  return LazyCore;
}();

function getDataset(el) {
  if (el.dataset) {
    return el.dataset;
  } else {
    var obj = {};

    for (var i = 0; i < el.attributes.length; i++) {
      var name_1 = el.attributes[i].nodeName;

      if (/^data-\w+$/.test(name_1)) {
        var key = name_1.split('-')[1];
        var value = el.attributes[i].nodeValue || undefined;

        if (['src', 'srcset', 'bg', 'bgset'].indexOf(key) !== -1) {
          obj[key] = value;
        }
      }
    }

    return obj;
  }
}

function getVueVersion(Vue) {
  return Number(Vue.version.split('.')[0]);
}
function setStyle(el, type, value) {
  var oldStyle = el.getAttribute('style') || '';
  var style = type === 'bg' ? "background-image: url(" + value + ");" : "background-image: -webkit-image-set(" + value + "); background-image: image-set(" + value + ");";
  var newStyle = oldStyle + style;
  el.setAttribute('style', newStyle);
}
function error(msg) {
  process.env.NODE_ENV === 'development' && console.error('[vue-lazy-loading error]: ' + msg);
}var index = {
  install: function (Vue, options) {
    var lazy = new LazyCore(options);
    var version = getVueVersion(Vue);
    var config;

    if (version < 2) {
      error('Support version 2.X and 3.X');
    } else if (version === 2) {
      config = {
        bind: lazy.bind.bind(lazy),
        update: lazy.update.bind(lazy),
        unbind: lazy.unbind.bind(lazy)
      };
    } else {
      config = {
        mounted: lazy.bind.bind(lazy),
        updated: lazy.update.bind(lazy),
        unmounted: lazy.unbind.bind(lazy)
      };
    }

    Vue.directive('lazy', config);
  }
};exports.default=index;Object.defineProperty(exports,'__esModule',{value:true});})));